; subkey1.asm     Original code from TTom, help from Hutch, Iczelion,
; 
; HKEY_LOCAL_MACHINE\Software\MASM.
; 
; I hope you find these useful. If some industrious chap would care to, 
; add a routine to the string write routine that checks the length of the  
; passed in string. This will save you one parameter to send, and would be  
; useful if the string isn't a constant and SIZEOF is not available.

    .386
    .model flat, stdcall
    option casemap :none   ; case sensitive
; -------------------------------------------------------------------------
include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\advapi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\advapi32.lib
; -------------------------------------------------------------------------
SetRegKeysz PROTO :DWORD, :DWORD, :DWORD, :DWORD
GetRegKeysz PROTO :DWORD, :DWORD, :DWORD, :DWORD
SetRegKeyDW PROTO :DWORD, :DWORD, :DWORD
GetRegKeyDW PROTO :DWORD, :DWORD, :DWORD
; -------------------------------------------------------------------------

.data

szKeyName       db      "Software\MASM\Registry Test\"  ,0
szStringValue   db      "Some String"                   ,0
RegistryText    db      "Some text."  ,0 ; Only This is our [shows in reg]
szDWValue       db      "Some DW"                       ,0
DubWord         DWORD   00214948H   ; this is a magic number
                                    ; think of it as 4 ASCII bytes
                                    ; and remember in memory it's stored
                                    ; least sig byte first (so the '00'
                                    ; goes last. (Hint: that makes it zero
                                    ; terminated)
DubWordBack     DWORD   ?

MsgCaption      db      "Create a registry key"    ,0
MsgBoxText1     db      "Creating a string key"         ,0
MsgBoxText2     db      "Reading the key value"         ,0
MsgBoxText3     db      "Creating a double word key"    ,0
MsgBoxText4     db      "Reading the double word"       ,0
MsgBoxText5     db      "Thats all folks !!!"           ,0
ErrorMessage    db      "Registry error!!!"             ,0
szBigBuffer     db      "                              ",0 ; 31 spaces
dwBBufLength    DWORD   SIZEOF szBigBuffer + 1


; -------------------------------------------------------------------------

.code
start:

    invoke MessageBox, NULL,ADDR MsgBoxText1, ADDR MsgCaption, MB_OK
    
; lets open and write a string key (creating it if necessary)

 invoke SetRegKeysz , ADDR RegistryText, ADDR szKeyName, ADDR szStringValue, SIZEOF szStringValue
    
; check if the registry string write succeeded

    .IF eax != ERROR_SUCCESS
        invoke MessageBox, NULL,ADDR ErrorMessage, ADDR MsgCaption, MB_OK
        invoke ExitProcess,NULL ; quit on any error
    .ENDIF

    invoke MessageBox, NULL,ADDR MsgBoxText2, ADDR MsgCaption, MB_OK

; now lets read our string value back

    invoke GetRegKeysz , ADDR szBigBuffer, ADDR szKeyName, ADDR szStringValue, ADDR dwBBufLength

; check if the registry read succeeded

    .IF eax != ERROR_SUCCESS
        invoke MessageBox, NULL,addr ErrorMessage, addr MsgCaption, MB_OK
        invoke ExitProcess,NULL ; quit on any error
    .ENDIF

; lets display the string we got back, it's now in the big buffer

    invoke MessageBox, NULL, ADDR szBigBuffer, ADDR MsgBoxText2, MB_OK

    invoke MessageBox, NULL,ADDR MsgBoxText3, ADDR MsgCaption, MB_OK

; now we write a double word value

    invoke SetRegKeyDW , ADDR DubWord, ADDR szKeyName, ADDR szDWValue

; check if the registry write succeeded

    .IF eax != ERROR_SUCCESS
        invoke MessageBox, NULL,ADDR ErrorMessage, ADDR MsgCaption, MB_OK
        invoke ExitProcess,NULL ; quit on any error
    .ENDIF

    invoke MessageBox, NULL,ADDR MsgBoxText4, ADDR MsgCaption, MB_OK

; now lets read our DWORD value back

    invoke GetRegKeyDW, ADDR DubWordBack, ADDR szKeyName, ADDR szDWValue

; check if the registry read succeeded

    .IF eax != ERROR_SUCCESS
        invoke MessageBox, NULL,addr ErrorMessage, addr MsgCaption, MB_OK
        invoke ExitProcess,NULL ; quit on any error
    .ENDIF

; lets display the DWORD we got back, it's now in the DubWordBack

    invoke MessageBox, NULL, ADDR DubWordBack, ADDR MsgBoxText2, MB_OK


; let's be doubly sure we got the same value back

    mov eax, DubWord
    .IF DubWordBack != eax
        invoke MessageBox, NULL,addr ErrorMessage, addr MsgCaption, MB_OK
        invoke ExitProcess,NULL ; quit on any error
    .ENDIF

    invoke MessageBox, NULL,ADDR MsgBoxText5, ADDR MsgCaption, MB_OK
    invoke ExitProcess,NULL

; -------------------------------------------------------------------------

SetRegKeysz  PROC lpszString:DWORD, lpszKeyName:DWORD, lpszValueName:DWORD, dwStringLength:DWORD
    LOCAL Disp  :DWORD
    LOCAL pKey  :DWORD
    invoke RegCreateKeyEx, HKEY_LOCAL_MACHINE,
                             lpszKeyName, NULL, NULL, 
                             REG_OPTION_NON_VOLATILE, 
                             KEY_ALL_ACCESS, NULL,
                             addr pKey, addr Disp
    .IF eax == ERROR_SUCCESS
        invoke RegSetValueEx, pKey, lpszValueName, 
                              NULL, REG_SZ,  ; 
                              lpszString, dwStringLength 
        invoke RegCloseKey, pKey
    .ENDIF
    ret
SetRegKeysz ENDP

; -------------------------------------------------------------------------
GetRegKeysz PROC lpszBuffer:DWORD, lpszKeyName:DWORD, 
                 lpszValueName:DWORD, dwStringLength:DWORD
    LOCAL TType :DWORD
    LOCAL pKey  :DWORD
    mov TType, REG_SZ  ; A null-terminated string. It will be a Unicode or ANSI string 
    invoke RegCreateKeyEx, HKEY_LOCAL_MACHINE,
                             lpszKeyName, NULL, NULL, 
                             REG_OPTION_NON_VOLATILE, 
                             KEY_ALL_ACCESS, NULL,
                             addr pKey, addr TType
    .IF eax == ERROR_SUCCESS
        mov eax, REG_DWORD
        mov TType, eax
        invoke RegQueryValueEx, pKey, lpszValueName,
                             NULL, ADDR TType, 
                             lpszBuffer, dwStringLength 
        invoke RegCloseKey, pKey
    .ENDIF
    ret
GetRegKeysz ENDP

; -------------------------------------------------------------------------
SetRegKeyDW PROC lpdwValue:DWORD, lpszKeyName:DWORD, lpszValueName:DWORD
    LOCAL Disp  :DWORD
    LOCAL pKey  :DWORD
    DW_SIZE     EQU     4
    invoke RegCreateKeyEx, HKEY_LOCAL_MACHINE,
                             lpszKeyName, NULL, NULL, 
                             REG_OPTION_NON_VOLATILE, 
                             KEY_ALL_ACCESS, NULL,
                             addr pKey, addr Disp
    .IF eax == ERROR_SUCCESS
        invoke RegSetValueEx, pKey, lpszValueName, 
                              NULL, REG_DWORD_LITTLE_ENDIAN, 
                              lpdwValue, DW_SIZE 
        invoke RegCloseKey, pKey
    .ENDIF
    ret
SetRegKeyDW ENDP

; -------------------------------------------------------------------------
GetRegKeyDW PROC lpdwValue:DWORD, lpszKeyName:DWORD, lpszValueName:DWORD
    LOCAL Temp  :DWORD
    LOCAL pKey  :DWORD
    LOCAL DWordSize:DWORD
    DW_SIZE EQU 4
    mov DWordSize, DW_SIZE
    invoke RegCreateKeyEx, HKEY_LOCAL_MACHINE,
                             lpszKeyName, NULL, NULL, 
                             REG_OPTION_NON_VOLATILE, 
                             KEY_ALL_ACCESS, NULL,
                             addr pKey, addr Temp
    .IF eax == ERROR_SUCCESS
        mov eax, REG_DWORD
        mov Temp, eax
        invoke RegQueryValueEx, pKey, lpszValueName, 
                             NULL, ADDR Temp, 
                             lpdwValue, ADDR DWordSize 
        invoke RegCloseKey, pKey
    .ENDIF
    ret
GetRegKeyDW ENDP

; -------------------------------------------------------------------------

end start
